## wpa 2.9

=== src/ap/Makefile ===
all: libap.a

clean:
	rm -f *~ *.o *.d *.gcno *.gcda *.gcov libap.a

install:
	@echo Nothing to be made.

include ../lib.rules

CFLAGS += -DHOSTAPD
CFLAGS += -DNEED_AP_MLME
CFLAGS += -DCONFIG_ETH_P_OUI
CFLAGS += -DCONFIG_HS20
CFLAGS += -DCONFIG_INTERWORKING
CFLAGS += -DCONFIG_IEEE80211R
CFLAGS += -DCONFIG_IEEE80211R_AP
CFLAGS += -DCONFIG_IEEE80211W
CFLAGS += -DCONFIG_WPS
CFLAGS += -DCONFIG_PROXYARP
CFLAGS += -DCONFIG_IPV6
CFLAGS += -DCONFIG_IAPP
CFLAGS += -DCONFIG_AIRTIME_POLICY

LIB_OBJS= \
	accounting.o \
	ap_config.o \
	ap_drv_ops.o \
	ap_list.o \
	ap_mlme.o \
	airtime_policy.o \
	authsrv.o \
	beacon.o \
	bss_load.o \
	ctrl_iface_ap.o \
	dfs.o \
	dhcp_snoop.o \
	drv_callbacks.o \
	eap_user_db.o \
	eth_p_oui.o \
	gas_serv.o \
	hostapd.o \
	hs20.o \
	hw_features.o \
	iapp.o \
	ieee802_11_auth.o \
	ieee802_11.o \
	ieee802_11_ht.o \
	ieee802_11_shared.o \
	ieee802_11_vht.o \
	ieee802_1x.o \
	neighbor_db.o \
	ndisc_snoop.o \
	p2p_hostapd.o \
	pmksa_cache_auth.o \
	preauth_auth.o \
	rrm.o \
	sta_info.o \
	tkip_countermeasures.o \
	utils.o \
	vlan.o \
	vlan_ifconfig.o \
	vlan_init.o \
	wmm.o \
	wnm_ap.o \
	wpa_auth.o \
	wpa_auth_ft.o \
	wpa_auth_glue.o \
	wpa_auth_ie.o \
	wps_hostapd.o \
	x_snoop.o

libap.a: $(LIB_OBJS)
	$(AR) crT $@ $?

-include $(OBJS:%.o=%.d)

=== debian/changelog ===
wpa (2:2.9-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Move source package lintian overrides to debian/source.
  * Use canonical URL in Vcs-Browser.
  * Rely on pre-initialized dpkg-architecture variables.
  * Update standards version to 4.4.1, no changes needed.

  [ Andrej Shadura ]
  * Disable CONFIG_DRIVER_MACSEC_QCA on kfreebsd.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 13 Jan 2020 16:28:58 +0100

wpa (2:2.9-5) unstable; urgency=medium

  * Fix erroneously inverted logic in postinst.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 13 Jan 2020 10:48:26 +0100

wpa (2:2.9-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Don’t export CC=cc (Closes: #921998).

  [ Andrej Shadura ]
  * Don’t act in hostapd.postinst if we’re running in a chrootless root.
  * Apply an upstream patch:
    - wpa_supplicant: Do not try to detect PSK mismatch during PTK rekeying.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 13 Jan 2020 10:37:10 +0100

wpa (2:2.9-3) unstable; urgency=medium

  * Add pkg.wpa.nogui and noudeb build profiles.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 04 Oct 2019 11:47:15 +0200

wpa (2:2.9-2) unstable; urgency=medium

  * SECURITY UPDATE:
    - AP mode PMF disconnection protection bypass.
      More details:
       + https://w1.fi/security/2019-7/
      Closes: #940080 (CVE-2019-16275)

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 04 Oct 2019 10:11:47 +0200

wpa (2:2.9-1) unstable; urgency=high

  * New upstream release (Closes: #934180):
    - SECURITY UPDATE (CVE-2019-13377):
      Timing-based side-channel attack against WPA3's Dragonfly handshake
      when using Brainpool curves.
      More details:
      + https://w1.fi/security/2019-6/
      + https://wpa3.mathyvanhoef.com/
  * Drop a patch applied upstream.
  * Update debian/watch.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 08 Aug 2019 15:59:02 +0200

=== debian/control ===
Source: wpa
Maintainer: Debian wpasupplicant Maintainers <wpa@packages.debian.org>
Uploaders:
 Andrej Shadura <andrewsh@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 12),
 libdbus-1-dev,
 libssl-dev,
 qtbase5-dev <!pkg.wpa.nogui>,
 libncurses5-dev,
 libpcsclite-dev,
 libnl-3-dev (>= 3.4.0~) [linux-any],
 libnl-genl-3-dev [linux-any],
 libnl-route-3-dev [linux-any],
 libpcap-dev [kfreebsd-any],
 libbsd-dev [kfreebsd-any],
 libreadline-dev,
 pkg-config,
 docbook-to-man,
 docbook-utils
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/debian/wpa
Vcs-Git: https://salsa.debian.org/debian/wpa.git
Homepage: https://w1.fi/wpa_supplicant/

Package: hostapd
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends},
 lsb-base
Breaks: initscripts (<< 2.88dsf-13.3)
Description: IEEE 802.11 AP and IEEE 802.1X/WPA/WPA2/EAP Authenticator
 Originally, hostapd was an optional user space component for Host AP
 driver. It adds more features to the basic IEEE 802.11 management
 included in the kernel driver: using external RADIUS authentication
 server for MAC address based access control, IEEE 802.1X Authenticator
 and dynamic WEP keying, RADIUS accounting, WPA/WPA2 (IEEE 802.11i/RSN)
 Authenticator and dynamic TKIP/CCMP keying.
 .
 The current version includes support for other drivers, an integrated
 EAP authenticator (i.e., allow full authentication without requiring
 an external RADIUS authentication server), and RADIUS authentication
 server for EAP authentication.
 .
 hostapd works with the following drivers:
 .
  * mac80211 based drivers with support for master mode [linux]
  * Host AP driver for Prism2/2.5/3 [linux]
  * Driver interface for FreeBSD net80211 layer [kfreebsd]
  * Any wired Ethernet driver for wired IEEE 802.1X authentication.

Package: wpagui
Architecture: linux-any kfreebsd-any
Build-Profiles: <!pkg.wpa.nogui>
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 wpasupplicant (>= 0.7.3~),
 libqt5svg5
Recommends: menu
Description: graphical user interface for wpa_supplicant
 wpagui provides a Qt interface for choosing which configured network
 to connect to. It also provides a method for browsing 802.11 SSID scan
 results, an event history log of messages generated by wpa_supplicant,
 and a method to add or edit wpa_supplicant networks.

Package: wpasupplicant
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 lsb-base,
 adduser
Suggests: wpagui,
 libengine-pkcs11-openssl
Breaks: initscripts (<< 2.88dsf-13.3)
Description: client support for WPA and WPA2 (IEEE 802.11i)
 WPA and WPA2 are methods for securing wireless networks, the former
 using IEEE 802.1X, and the latter using IEEE 802.11i. This software
 provides key negotiation with the WPA Authenticator, and controls
 association with IEEE 802.11i networks.

Package: wpasupplicant-udeb
Architecture: linux-any
Build-Profiles: <!noudeb>
Section: debian-installer
Priority: standard
Depends: ${shlibs:Depends},
 ${misc:Depends},
 busybox-udeb
Package-Type: udeb
Description: Client support for WPA and WPA2 (IEEE 802.11i)
 WPA and WPA2 are methods for securing wireless networks, the former
 using IEEE 802.1X, and the latter using IEEE 802.11i. This software
 provides key negotiation with the WPA Authenticator, and controls
 association with IEEE 802.11i networks.
 .
 This is a udeb of wpasupplicant for use by the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt5
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# The build system doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to
# enable the missing (hardening) flags
DEB_CFLAGS_MAINT_APPEND   = -MMD -Wall $(shell dpkg-buildflags --get CPPFLAGS)
DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
export DEB_CFLAGS_MAINT_APPEND DEB_CXXFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

UCFLAGS   = -MMD -Wall -fPIC $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)

BINDIR    = /sbin
V = 1

PKG_CONFIG ?= $(DEB_HOST_GNU_TYPE)-pkg-config

export BINDIR V PKG_CONFIG

include /usr/share/dpkg/architecture.mk
HOSTAPD_DOT_CONFIG            := debian/config/hostapd/$(DEB_HOST_ARCH_OS)
WPASUPPLICANT_DOT_CONFIG      := debian/config/wpasupplicant/$(DEB_HOST_ARCH_OS)
WPASUPPLICANT_UDEB_DOT_CONFIG := debian/config/wpasupplicant/$(DEB_HOST_ARCH_OS)-udeb

### start dh overrides
override_dh_auto_configure:
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	dh_auto_configure --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	                  --buildsystem=qmake
endif

override_dh_auto_build:
	# build documentation
	dh_auto_build --sourcedirectory=wpa_supplicant/doc/docbook \
	              --buildsystem=makefile \
	              -- man
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	# build wpasupplicant-udeb
	cp -v --remove-destination $(WPASUPPLICANT_UDEB_DOT_CONFIG) wpa_supplicant/.config
	CFLAGS="$(UCFLAGS)" dh_auto_build --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
	mv -v wpa_supplicant/wpa_supplicant wpa_supplicant/wpa_supplicant-udeb
	dh_auto_clean --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
endif
	# build wpasupplicant
	cp -v --remove-destination $(WPASUPPLICANT_DOT_CONFIG) wpa_supplicant/.config
	dh_auto_build --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	# build wpa_gui-qt4
	dh_auto_build --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	              --buildsystem=qmake
endif
	dh_auto_clean --sourcedirectory=src --buildsystem=makefile
	# build hostapd
	cp -v --remove-destination $(HOSTAPD_DOT_CONFIG) hostapd/.config
	dh_auto_build --sourcedirectory=hostapd \
	              --buildsystem=makefile
	dh_auto_clean --sourcedirectory=src --buildsystem=makefile

override_dh_auto_clean:
	dh_auto_clean --sourcedirectory=wpa_supplicant/doc/docbook \
	              --buildsystem=makefile
	dh_auto_clean --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	dh_auto_clean --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	              --buildsystem=qmake
	-find wpa_supplicant/wpa_gui-qt4 -type d -name \.moc -exec rm -rf {} \;
	-find wpa_supplicant/wpa_gui-qt4 -type d -name \.ui  -exec rm -rf {} \;
	-find wpa_supplicant/wpa_gui-qt4 -type d -name \.obj -exec rm -rf {} \;
endif
	dh_auto_clean --sourcedirectory=hostapd \
	              --buildsystem=makefile

override_dh_auto_install:
	$(info Skip dh_auto_install ...)

override_dh_clean:
	# make sure to remove the staging directory for the udeb
	rm -rf debian/wpasupplicant-udeb
	dh_clean

override_dh_install:
	dh_install
	# install D-Bus service activation files & configuration
	install --mode=644 -D wpa_supplicant/dbus/dbus-wpa_supplicant.conf \
		debian/wpasupplicant/etc/dbus-1/system.d/wpa_supplicant.conf
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	# Install udeb
	install --mode=755 -D wpa_supplicant/wpa_supplicant-udeb \
		debian/wpasupplicant-udeb/sbin/wpa_supplicant
endif

override_dh_installchangelogs:
	dh_installchangelogs --package=hostapd hostapd/ChangeLog
	dh_installchangelogs --package=wpasupplicant wpa_supplicant/ChangeLog
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	dh_installchangelogs --package=wpagui wpa_supplicant/ChangeLog
endif
### end dh overrides

%:
	dh ${@}

get-orig-source:
	chmod +x $(CURDIR)/debian/get-orig-source
	$(CURDIR)/debian/get-orig-source $(CURDIR)
